<?php

class ControllerPaymentIntellectmoney extends Controller {

    private $error = array();

    public function index() {
        $this->load->language('payment/intellectmoney');

        if (method_exists($this->document, 'setTitle'))
            $this->document->setTitle($this->language->get('heading_title'));
        else
            $this->document->title = $this->language->get('heading_title');

        $this->load->model('setting/setting');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
            
            $this->model_setting_setting->editSetting('intellectmoney', $this->request->post);
            $this->session->data['success'] = $this->language->get('text_success');

            $this->response->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $data['heading_title'] = $this->language->get('heading_title');
        $data['text_edit'] = $this->language->get('text_edit');

        $data['entry_eshopid'] = $this->language->get('entry_eshopid');
        $data['entry_secret_key'] = $this->language->get('entry_secret_key');
        $data['entry_result_url'] = $this->language->get('entry_result_url');
        $data['entry_success_url'] = $this->language->get('entry_success_url');
        $data['entry_fail_url'] = $this->language->get('entry_fail_url');

        $data['text_enabled'] = $this->language->get('text_enabled');
        $data['text_disabled'] = $this->language->get('text_disabled');
        $data['text_all_zones'] = $this->language->get('text_all_zones');

        $data['entry_order_status_pending'] = $this->language->get('entry_order_status_pending');
        $data['entry_order_status'] = $this->language->get('entry_order_status');
        $data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
        $data['entry_status'] = $this->language->get('entry_status');
        $data['entry_sort_order'] = $this->language->get('entry_sort_order');

        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');

        $data['tab_general'] = $this->language->get('tab_general');

        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }

        if (isset($this->error['error_eshop_id'])) {
            $data['error_eshop_id'] = $this->error['error_eshop_id'];
        } else {
            $data['error_eshop_id'] = '';
        }

        if (isset($this->error['secret_key'])) {
            $data['error_secret_key'] = $this->error['secret_key'];
        } else {
            $data['error_secret_key'] = '';
        }

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_payment'),
            'href' => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('payment/intellectmoney', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['action'] = $this->url->link('payment/intellectmoney', 'token=' . $this->session->data['token'], 'SSL');

        $data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');


        // Номер магазина 
        if (isset($this->request->post['intellectmoney_eshopid'])) {
            $data['intellectmoney_eshopid'] = $this->request->post['intellectmoney_eshopid'];
        } else {
            $data['intellectmoney_eshopid'] = $this->config->get('intellectmoney_eshopid');
        }

        // Секретный ключ
        if (isset($this->request->post['intellectmoney_secret_key'])) {
            $data['intellectmoney_secret_key'] = $this->request->post['intellectmoney_secret_key'];
        } else {
            $data['intellectmoney_secret_key'] = $this->config->get('intellectmoney_secret_key');
        }


        // URL
        $data['intellectmoney_result_url'] = HTTP_CATALOG . 'index.php?route=payment/intellectmoney/callback';


        if (isset($this->request->post['intellectmoney_order_status_pending_id'])) {
            $data['intellectmoney_order_status_pending_id'] = $this->request->post['intellectmoney_order_status_pending_id'];
        } else {
            $data['intellectmoney_order_status_pending_id'] = $this->config->get('intellectmoney_order_status_pending_id');
        }

        if (isset($this->request->post['intellectmoney_order_status_id'])) {
            $data['intellectmoney_order_status_id'] = $this->request->post['intellectmoney_order_status_id'];
        } else {
            $data['intellectmoney_order_status_id'] = $this->config->get('intellectmoney_order_status_id');
        }


        $this->load->model('localisation/order_status');

        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

        if (isset($this->request->post['intellectmoney_geo_zone_id'])) {
            $data['intellectmoney_geo_zone_id'] = $this->request->post['intellectmoney_geo_zone_id'];
        } else {
            $data['intellectmoney_geo_zone_id'] = $this->config->get('intellectmoney_geo_zone_id');
        }

        $this->load->model('localisation/geo_zone');

        $data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

        if (isset($this->request->post['intellectmoney_status'])) {
            $data['intellectmoney_status'] = $this->request->post['intellectmoney_status'];
        } else {
            $data['intellectmoney_status'] = $this->config->get('intellectmoney_status');
        }

        if (isset($this->request->post['intellectmoney_sort_order'])) {
            $data['intellectmoney_sort_order'] = $this->request->post['intellectmoney_sort_order'];
        } else {
            $data['intellectmoney_sort_order'] = $this->config->get('intellectmoney_sort_order');
        }


        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('payment/intellectmoney.tpl', $data));
    }

    private function validate() {
        if (!$this->user->hasPermission('modify', 'payment/intellectmoney')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        if (!$this->request->post['intellectmoney_secret_key']) {
            $this->error['secret_key'] = $this->language->get('error_secret_key');
        }

        if (!$this->request->post['intellectmoney_eshopid']) {
            $this->error['error_eshop_id'] = $this->language->get('error_eshop_id');
        }

        if (!$this->error) {
            return TRUE;
        } else {
            return FALSE;
        }
    }

}

?>